// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockPluginPlatforms is an autogenerated mock type for the PluginPlatforms type
type MockPluginPlatforms struct {
	mock.Mock
}

// CreatePluginPlatform provides a mock function with given fields: ctx, pluginPlatform
func (_m *MockPluginPlatforms) CreatePluginPlatform(ctx context.Context, pluginPlatform *models.PluginPlatform) (*models.PluginPlatform, error) {
	ret := _m.Called(ctx, pluginPlatform)

	if len(ret) == 0 {
		panic("no return value specified for CreatePluginPlatform")
	}

	var r0 *models.PluginPlatform
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginPlatform) (*models.PluginPlatform, error)); ok {
		return rf(ctx, pluginPlatform)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginPlatform) *models.PluginPlatform); ok {
		r0 = rf(ctx, pluginPlatform)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginPlatform)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.PluginPlatform) error); ok {
		r1 = rf(ctx, pluginPlatform)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeletePluginPlatform provides a mock function with given fields: ctx, pluginPlatform
func (_m *MockPluginPlatforms) DeletePluginPlatform(ctx context.Context, pluginPlatform *models.PluginPlatform) error {
	ret := _m.Called(ctx, pluginPlatform)

	if len(ret) == 0 {
		panic("no return value specified for DeletePluginPlatform")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginPlatform) error); ok {
		r0 = rf(ctx, pluginPlatform)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetPluginPlatformByID provides a mock function with given fields: ctx, id
func (_m *MockPluginPlatforms) GetPluginPlatformByID(ctx context.Context, id string) (*models.PluginPlatform, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginPlatformByID")
	}

	var r0 *models.PluginPlatform
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PluginPlatform, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PluginPlatform); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginPlatform)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPluginPlatformByPRN provides a mock function with given fields: ctx, prn
func (_m *MockPluginPlatforms) GetPluginPlatformByPRN(ctx context.Context, prn string) (*models.PluginPlatform, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginPlatformByPRN")
	}

	var r0 *models.PluginPlatform
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PluginPlatform, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PluginPlatform); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginPlatform)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPluginPlatforms provides a mock function with given fields: ctx, input
func (_m *MockPluginPlatforms) GetPluginPlatforms(ctx context.Context, input *GetPluginPlatformsInput) (*PluginPlatformsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetPluginPlatforms")
	}

	var r0 *PluginPlatformsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetPluginPlatformsInput) (*PluginPlatformsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetPluginPlatformsInput) *PluginPlatformsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*PluginPlatformsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetPluginPlatformsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdatePluginPlatform provides a mock function with given fields: ctx, pluginPlatform
func (_m *MockPluginPlatforms) UpdatePluginPlatform(ctx context.Context, pluginPlatform *models.PluginPlatform) (*models.PluginPlatform, error) {
	ret := _m.Called(ctx, pluginPlatform)

	if len(ret) == 0 {
		panic("no return value specified for UpdatePluginPlatform")
	}

	var r0 *models.PluginPlatform
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginPlatform) (*models.PluginPlatform, error)); ok {
		return rf(ctx, pluginPlatform)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.PluginPlatform) *models.PluginPlatform); ok {
		r0 = rf(ctx, pluginPlatform)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PluginPlatform)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.PluginPlatform) error); ok {
		r1 = rf(ctx, pluginPlatform)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockPluginPlatforms creates a new instance of MockPluginPlatforms. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockPluginPlatforms(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockPluginPlatforms {
	mock := &MockPluginPlatforms{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
